
import java.io.*;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Queue;

import javax.sound.sampled.*;

/* Passa baixa de n estagios para arquivos wav com amostra de 8 bits */
public class PassaBaixaEstagios
{
  private AudioInputStream entrada = null;
  private SourceDataLine fonteSonora;
  private AudioFormat formatoDaEntrada;
  private DataLine.Info descricaoDaEntrada;
  private long tamanhoStream;
  private int tamanhoFrame;
  private int numeroDeEstagios;
  private int[] amostras;
  private String nomeArq;
  

    public PassaBaixaEstagios(String nomeArq)
    {
      try
      {
        //preparando a criacao de um SourceDataLine
    	this.nomeArq = nomeArq;  
        entrada = AudioSystem.getAudioInputStream(new File(nomeArq));
        formatoDaEntrada = entrada.getFormat();
        descricaoDaEntrada = new DataLine.Info(SourceDataLine.class, formatoDaEntrada);
        fonteSonora = (SourceDataLine) AudioSystem.getLine(descricaoDaEntrada);

        //armazenando informacoes importantes para salvamento posterior
        tamanhoStream = entrada.getFrameLength();
        tamanhoFrame = formatoDaEntrada.getFrameSize();
       
      }
      catch (Exception e)
      {
        e.printStackTrace();
      }
   }

   private byte processaAmostra(int amostraAtual, int execucoes) {
	
	   amostras[execucoes%numeroDeEstagios] = amostraAtual;
	   int media=0;
	   for (int i = 0; i < numeroDeEstagios; i++) {
		   media+=amostras[i];
	   }
	   return (byte) ( media / numeroDeEstagios);
	   
	
	   
   }
   
   
   public void Executa(int numeroEstagios)
   {
      int tamanhoArray = (int) tamanhoStream*tamanhoFrame;
      byte[] inAux = new byte[tamanhoArray];
      byte[] outAux = new byte[tamanhoArray];
      int  amostraAtual=0, amostraAnterior=0;
      int numBytesLidos;
      numeroDeEstagios = numeroEstagios;
      amostras = new int[numeroDeEstagios];

      try
		{
        //Criar um arquivo temporario
        ByteArrayOutputStream streamResultado = new ByteArrayOutputStream();
        

        //preparar o SourceDataLine para tocar
        fonteSonora.open();
        //garante que nao vai ter lixo na memoria
        fonteSonora.flush();
        fonteSonora.start();
        
        int contador = 0;
        while ((numBytesLidos = entrada.read(inAux)) != -1)
        {
          for(int i=0; i <numBytesLidos;i++)
          {
            
            /*
            Arquivos wav com 8 bits, em diferentemente dos outros, possui codificacao
            PCM_UNSIGNED. Byte por sua vez, eh signed, uma forma de resolver o problema
            eh usar operadores bitwise, que, logicamente, nao levam sinal em consideracao.
            */
        	outAux[i] = processaAmostra(inAux[i]&0xFF, contador++);
          }//for

           //reproduz o som
           fonteSonora.write(outAux,0,numBytesLidos);

           //escreve no arquivo temporario
           streamResultado.write(outAux,0, numBytesLidos);

        } //while

        //libera o stream
        streamResultado.close();

        //abre o arquivo escrito pelo streamTemp como AudioInputStream
        AudioInputStream entradaFiltrada =  new AudioInputStream(
                                                  new ByteArrayInputStream(streamResultado.toByteArray()),
                                                  formatoDaEntrada,
                                                  tamanhoStream);

        String novoNome = nomeArq.substring(0, nomeArq.indexOf("."))+"_"+ Integer.toString(numeroDeEstagios)+".wav";
        AudioSystem.write(entradaFiltrada,AudioFileFormat.Type.WAVE,new FileOutputStream(novoNome));

        entradaFiltrada.close();

	   }
		catch (Exception e)
		{
			System.out.println(e);
		}
	}

   public static void main(String args[])
   {
      PassaBaixaEstagios f = new PassaBaixaEstagios("welcome_8.wav");
      f.Executa(50);
      System.out.println("acabou");
   }
}

